## Script (Python) "pay_online"
##bind container=container
##bind context=context
##bind namespace=
##bind script=script
##bind subpath=traverse_subpath
##parameters=
##title=
##
# $Id: pay_online.py 1224 2007-01-07 15:20:56Z joachim $
"""
pay online
"""
import logging
logger = logging.getLogger('EPayment.')
import DateTime
import time

request = context.REQUEST
students = context.portal_url.getPortalObject().campus.students

student_id = context.getStudentId()
if student_id is None:
    return context.REQUEST.RESPONSE.redirect("%s/srp_anonymous_view" % context.portal_url())

student = getattr(students,student_id)
sbrain = context.students_catalog(id=student_id)[0]
res = context.portal_catalog(portal_type="Certificate",
                                     id = sbrain.course)
if not res:
    return None
sfc = res[0].getObject().getContent().school_fee_code
info = {}
info['type_code'] = "ART" #sfc
info['type_description'] = "Schoolfee %s for 2006/2007 Session" % sfc
info['pay_bill_to'] = sbrain.name
info['pay_ship_to'] = "University of Benin"
info['student_id'] = student_id
info['student_name'] = sbrain.name
info['student_email'] = sbrain.email
info['pay_date'] = DateTime.DateTime().strftime("%d%m%y%H%M%S")
order_id = info['order_id'] = "%d" % int(time.time()*1000)
info['order_id'] = "%s%s" % (student_id[1:],order_id)
info['amount'] = "75000"
if "payments" not in student.objectIds():
    student.invokeFactory('PaymentsFolder','payment')
    payments = getattr(student,'payments')
    d = {}
    d['Title'] = 'Online Payments'
    payment.getContent().edit(mapping=d)
else:
    payments = getattr(student,'payments')
p_id = "p%s" % order_id
payments.invokeFactory('Payment', p_id)
payment = getattr(payments,p_id)
d = {}
d.update(info)
d['Title'] = "%(payment_type_description)s %(pay_date) %(amount)s N" % info
payment.getContent().edit(mapping=d)
info['callback_url'] = "%s/payments/%s/epayment_cb" % (student.absolute_url(),p_id)
logger.info('"%(student_id)s","%(payment_type_description)s", "%(amount)s N"' % info)
return context.wema_form(info=info)
